// This file is automatically generated from smb.pac.

#include "smb_pac.h"

namespace BinPAC {

SMB_dos_error::SMB_dos_error()
	{
	error_class_ = 0;
	reserved_ = 0;
	error_ = 0;
	}

SMB_dos_error::~SMB_dos_error()
	{
	}

int SMB_dos_error::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_dos_error:val"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_dos_error:val",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "error_class"
	error_class_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "reserved"
	reserved_ = *((uint8 *) ((t_begin_of_data + 1)));
	
	// Parse "error"
	error_ = UnMarshall<uint16>((t_begin_of_data + 2), error_, t_byteorder);
	
	return 4;
	}

SMB_error::SMB_error(int arg_err_status_type)
	{
	err_status_type_ = arg_err_status_type;
	val_case_index_ = -1;
	}

SMB_error::~SMB_error()
	{
	switch ( val_case_index() )
		{
		case 0:
			// Clean up "dos_error"
			{
			delete val_.dos_error_;
			}
			break;
		case 1:
			// Clean up "status"
			{
			}
			break;
		}
	}

int SMB_error::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_error:val"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_error:val",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	val_case_index_ = err_status_type();
	switch ( val_case_index() )
		{
		case 0:
			// Parse "dos_error"
			{
			val_.dos_error_ = new SMB_dos_error();
			val_.dos_error_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
			}
			break;
		case 1:
			// Parse "status"
			{
			val_.status_ = UnMarshall<int32>(t_begin_of_data, val_.status_, t_byteorder);
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("SMB_error", val_case_index());
			break;
		}
	return 4;
	}

SMB_header::SMB_header()
	{
	make_array(protocol_, 0);
	command_ = 0;
	err_status_type_ = 0;
	status_ = 0;
	flags_ = 0;
	flags2_ = 0;
	tid_ = 0;
	pid_ = 0;
	uid_ = 0;
	mid_ = 0;
	unicode_ = 0;
	}

SMB_header::~SMB_header()
	{
	delete_array(protocol_);
	delete status_;
	}

int SMB_header::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_header:val"
	if ( t_begin_of_data + (32) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_header:val",
			(0) + (32), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "protocol"
	int t_protocol__arraylength = 4;
	make_array<uint8>(protocol_, t_protocol__arraylength);
	const uint8* t_protocol__elem__data = t_begin_of_data;
	for ( int t_protocol__elem__it = 0; 
		t_protocol__elem__it < t_protocol__arraylength; 
		++t_protocol__elem__it )
		{
		uint8 t_protocol__elem;
		t_protocol__elem = *((uint8 *) (t_protocol__elem__data));
		protocol_.v[t_protocol__elem__it] = t_protocol__elem;
		t_protocol__elem__data += 1;
		}
	
	// Parse "command"
	command_ = *((uint8 *) ((t_begin_of_data + 4)));
	
	// Parse "flags2"
	byteorder_ = littleendian;
	flags2_ = UnMarshall<uint16>((t_begin_of_data + 10), flags2_, byteorder());
	err_status_type_ =  ( flags2() >> 14 )  & 1;
	
	// Parse "status"
	status_ = new SMB_error(err_status_type());
	status_->parse((t_begin_of_data + 5), t_end_of_data, byteorder());
	
	// Parse "flags"
	flags_ = *((uint8 *) ((t_begin_of_data + 9)));
	
	// Parse "flags2"
	
	
	// Parse "tid"
	tid_ = UnMarshall<uint16>((t_begin_of_data + 24), tid_, byteorder());
	
	// Parse "pid"
	pid_ = UnMarshall<uint16>((t_begin_of_data + 26), pid_, byteorder());
	
	// Parse "uid"
	uid_ = UnMarshall<uint16>((t_begin_of_data + 28), uid_, byteorder());
	
	// Parse "mid"
	mid_ = UnMarshall<uint16>((t_begin_of_data + 30), mid_, byteorder());
	
	unicode_ =  ( flags2() >> 15 )  & 1;
	
	return 32;
	}

SMB_body::SMB_body()
	{
	word_count_ = 0;
	make_array(parameter_words_, 0);
	byte_count_ = 0;
	body_length_ = 0;
	}

SMB_body::~SMB_body()
	{
	delete_array(parameter_words_);
	}

int SMB_body::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_body:word_count"
	if ( t_begin_of_data + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_body:word_count",
			(0) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "parameter_words"
	int t_parameter_words__arraylength = word_count();
	int t_parameter_words__size = 2 * t_parameter_words__arraylength;
	// Checking out-of-bound for "SMB_body:parameter_words"
	if ( (t_begin_of_data + 1) + (t_parameter_words__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_body:parameter_words",
			(1) + (t_parameter_words__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint16>(parameter_words_, t_parameter_words__arraylength);
	const uint8* t_parameter_words__elem__data = (t_begin_of_data + 1);
	for ( int t_parameter_words__elem__it = 0; 
		t_parameter_words__elem__it < t_parameter_words__arraylength; 
		++t_parameter_words__elem__it )
		{
		uint16 t_parameter_words__elem;
		byteorder_ = littleendian;
		t_parameter_words__elem = UnMarshall<uint16>(t_parameter_words__elem__data, t_parameter_words__elem, byteorder());
		parameter_words_.v[t_parameter_words__elem__it] = t_parameter_words__elem;
		t_parameter_words__elem__data += 2;
		}
	
	const uint8* const t_dataptr_after_parameter_words = (t_begin_of_data + 1) + (t_parameter_words__size);
	// Checking out-of-bound for "SMB_body:byte_count"
	if ( t_dataptr_after_parameter_words + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_body:byte_count",
			((t_dataptr_after_parameter_words - t_begin_of_data)) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte_count"
	byte_count_ = UnMarshall<uint16>(t_dataptr_after_parameter_words, byte_count_, byteorder());
	
	body_length_ = 1 + word_count() * 2 + 2 + byte_count();
	
	int t_val__size = (t_dataptr_after_parameter_words + 2) - t_begin_of_data;
	return t_val__size;
	}

SMB_ascii_string::SMB_ascii_string()
	{
	make_array(val_, 0);
	}

SMB_ascii_string::~SMB_ascii_string()
	{
	delete_array(val_);
	}

int SMB_ascii_string::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	std::vector<uint8> t_val__vec;
	const uint8* t_val__elem__data = t_begin_of_data;
	for ( int t_val__elem__it = 0; 
		/* forever */; 
		++t_val__elem__it )
		{
		// Checking out-of-bound for "val"
		if ( t_val__elem__data + (1) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("val",
				((t_val__elem__data - t_begin_of_data)) + (1), 
				(t_end_of_data) - (t_begin_of_data));
			}
		if ( // Have we reached the end of the sequence?
		     t_val__elem__data[0] == 0 
		   )
			{
			t_val__elem__data += 1;
			break;
			}
		uint8 t_val__elem;
		// Checking out-of-bound for "SMB_ascii_string:val__elem"
		if ( t_val__elem__data + (1) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("SMB_ascii_string:val__elem",
				((t_val__elem__data - t_begin_of_data)) + (1), 
				(t_end_of_data) - (t_begin_of_data));
			}
		t_val__elem = *((uint8 *) (t_val__elem__data));
		t_val__vec.push_back(t_val__elem);
		t_val__elem__data += 1;
		}
	make_array<uint8>(val_, t_val__vec.size());
	for ( int t_val__elem__it = 0; t_val__elem__it < val().length; ++t_val__elem__it )
		val_[t_val__elem__it] = t_val__vec[t_val__elem__it];
	int t_val__size = t_val__elem__data - t_begin_of_data;
	return t_val__size;
	}

SMB_unicode_string::SMB_unicode_string(int arg_offset)
	{
	offset_ = arg_offset;
	make_array(s_, 0);
	}

SMB_unicode_string::~SMB_unicode_string()
	{
	delete_array(s_);
	}

int SMB_unicode_string::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	
	const uint8* const t_dataptr_after_pad = t_begin_of_data + (offset() & 1);
	// Parse "s"
	std::vector<uint16> t_s__vec;
	const uint8* t_s__elem__data = t_dataptr_after_pad;
	for ( int t_s__elem__it = 0; 
		/* forever */; 
		++t_s__elem__it )
		{
		// Checking out-of-bound for "s"
		if ( t_s__elem__data + (2) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("s",
				((t_s__elem__data - t_begin_of_data)) + (2), 
				(t_end_of_data) - (t_begin_of_data));
			}
		if ( // Have we reached the end of the sequence?
		     t_s__elem__data[0] == 0 &&
		     t_s__elem__data[1] == 0 
		   )
			{
			t_s__elem__data += 2;
			break;
			}
		uint16 t_s__elem;
		// Checking out-of-bound for "SMB_unicode_string:s__elem"
		if ( t_s__elem__data + (2) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("SMB_unicode_string:s__elem",
				((t_s__elem__data - t_begin_of_data)) + (2), 
				(t_end_of_data) - (t_begin_of_data));
			}
		t_s__elem = UnMarshall<uint16>(t_s__elem__data, t_s__elem, t_byteorder);
		t_s__vec.push_back(t_s__elem);
		t_s__elem__data += 2;
		}
	make_array<uint16>(s_, t_s__vec.size());
	for ( int t_s__elem__it = 0; t_s__elem__it < s().length; ++t_s__elem__it )
		s_[t_s__elem__it] = t_s__vec[t_s__elem__it];
	int t_s__size = t_s__elem__data - t_dataptr_after_pad;
	
	const uint8* const t_dataptr_after_s = t_dataptr_after_pad + (t_s__size);
	int t_val__size = t_dataptr_after_s - t_begin_of_data;
	return t_val__size;
	}

SMB_string::SMB_string(int arg_unicode, int arg_offset)
	{
	unicode_ = arg_unicode;
	offset_ = arg_offset;
	val_case_index_ = -1;
	}

SMB_string::~SMB_string()
	{
	switch ( val_case_index() )
		{
		case 0:
			// Clean up "a"
			{
			delete val_.a_;
			}
			break;
		default:
			// Clean up "u"
			{
			delete val_.u_;
			}
			break;
		}
	}

int SMB_string::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	int t_val__size;
	val_case_index_ = unicode();
	switch ( val_case_index() )
		{
		case 0:
			// Parse "a"
			{
			val_.a_ = new SMB_ascii_string();
			int t_a__size = 
				val_.a_->parse(t_begin_of_data, t_end_of_data, bigendian);
			t_val__size = t_a__size;
			}
			break;
		default:
			// Parse "u"
			{
			val_.u_ = new SMB_unicode_string(offset());
			int t_u__size = 
				val_.u_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
			t_val__size = t_u__size;
			}
			break;
		}
	return t_val__size;
	}

SMB_andx::SMB_andx()
	{
	command_ = 0;
	reserved_ = 0;
	offset_ = 0;
	}

SMB_andx::~SMB_andx()
	{
	}

int SMB_andx::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_andx:val"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_andx:val",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "command"
	command_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "reserved"
	reserved_ = *((uint8 *) ((t_begin_of_data + 1)));
	
	// Parse "offset"
	offset_ = UnMarshall<uint16>((t_begin_of_data + 2), offset_, t_byteorder);
	
	return 4;
	}

SMB_generic_andx::SMB_generic_andx()
	{
	word_count_ = 0;
	andx_u_case_index_ = -1;
	}

SMB_generic_andx::~SMB_generic_andx()
	{
	switch ( andx_u_case_index() )
		{
		case 0:
			// Clean up "null"
			{
			}
			break;
		default:
			// Clean up "andx"
			{
			delete andx_u_.andx_;
			}
			break;
		}
	}

int SMB_generic_andx::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_generic_andx:word_count"
	if ( t_begin_of_data + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_generic_andx:word_count",
			(0) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "andx_u"
	int t_andx_u__size;
	andx_u_case_index_ = word_count();
	switch ( andx_u_case_index() )
		{
		case 0:
			// Parse "null"
			{
			// Checking out-of-bound for "SMB_generic_andx:null"
			if ( (t_begin_of_data + 1) + (0) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("SMB_generic_andx:null",
					(1) + (0), 
					(t_end_of_data) - (t_begin_of_data));
				}
			t_andx_u__size = 0;
			}
			break;
		default:
			// Parse "andx"
			{
			andx_u_.andx_ = new SMB_andx();
			andx_u_.andx_->parse((t_begin_of_data + 1), t_end_of_data, t_byteorder);
			t_andx_u__size = 4;
			}
			break;
		}
	
	const uint8* const t_dataptr_after_andx_u = (t_begin_of_data + 1) + (t_andx_u__size);
	int t_val__size = t_dataptr_after_andx_u - t_begin_of_data;
	return t_val__size;
	}

SMB_tree_connect_andx::SMB_tree_connect_andx(int arg_unicode)
	{
	unicode_ = arg_unicode;
	word_count_ = 0;
	andx_ = 0;
	flags_ = 0;
	password_length_ = 0;
	byte_count_ = 0;
	make_array(password_, 0);
	path_ = 0;
	service_ = 0;
	}

SMB_tree_connect_andx::~SMB_tree_connect_andx()
	{
	delete andx_;
	delete_array(password_);
	delete path_;
	delete service_;
	}

int SMB_tree_connect_andx::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_tree_connect_andx:byte_count"
	if ( (t_begin_of_data + 9) + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_tree_connect_andx:byte_count",
			(9) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "andx"
	andx_ = new SMB_andx();
	andx_->parse((t_begin_of_data + 1), t_end_of_data, t_byteorder);
	
	// Parse "flags"
	flags_ = UnMarshall<uint16>((t_begin_of_data + 5), flags_, t_byteorder);
	
	// Parse "password_length"
	password_length_ = UnMarshall<uint16>((t_begin_of_data + 7), password_length_, t_byteorder);
	
	// Parse "byte_count"
	byte_count_ = UnMarshall<uint16>((t_begin_of_data + 9), byte_count_, t_byteorder);
	
	// Parse "password"
	int t_password__arraylength = password_length();
	int t_password__size = 1 * t_password__arraylength;
	// Checking out-of-bound for "SMB_tree_connect_andx:password"
	if ( (t_begin_of_data + 11) + (t_password__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_tree_connect_andx:password",
			(11) + (t_password__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(password_, t_password__arraylength);
	const uint8* t_password__elem__data = (t_begin_of_data + 11);
	for ( int t_password__elem__it = 0; 
		t_password__elem__it < t_password__arraylength; 
		++t_password__elem__it )
		{
		uint8 t_password__elem;
		t_password__elem = *((uint8 *) (t_password__elem__data));
		password_.v[t_password__elem__it] = t_password__elem;
		t_password__elem__data += 1;
		}
	
	const uint8* const t_dataptr_after_password = (t_begin_of_data + 11) + (t_password__size);
	// Parse "path"
	path_ = new SMB_string(unicode(), (t_dataptr_after_password - t_begin_of_data));
	int t_path__size = 
		path_->parse(t_dataptr_after_password, t_end_of_data, t_byteorder);
	
	const uint8* const t_dataptr_after_path = t_dataptr_after_password + (t_path__size);
	// Parse "service"
	service_ = new SMB_ascii_string();
	int t_service__size = 
		service_->parse(t_dataptr_after_path, t_end_of_data, bigendian);
	
	const uint8* const t_dataptr_after_service = t_dataptr_after_path + (t_service__size);
	int t_val__size = t_dataptr_after_service - t_begin_of_data;
	return t_val__size;
	}

SMB_nt_create_andx::SMB_nt_create_andx(int arg_unicode)
	{
	unicode_ = arg_unicode;
	word_count_ = 0;
	andx_ = 0;
	reserved_ = 0;
	name_length_ = 0;
	flags_ = 0;
	make_array(rest_words_, 0);
	byte_count_ = 0;
	name_ = 0;
	}

SMB_nt_create_andx::~SMB_nt_create_andx()
	{
	delete andx_;
	delete_array(rest_words_);
	delete name_;
	}

int SMB_nt_create_andx::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_nt_create_andx:flags"
	if ( (t_begin_of_data + 8) + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_nt_create_andx:flags",
			(8) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "andx"
	andx_ = new SMB_andx();
	andx_->parse((t_begin_of_data + 1), t_end_of_data, t_byteorder);
	
	// Parse "reserved"
	reserved_ = *((uint8 *) ((t_begin_of_data + 5)));
	
	// Parse "name_length"
	name_length_ = UnMarshall<uint16>((t_begin_of_data + 6), name_length_, t_byteorder);
	
	// Parse "flags"
	flags_ = UnMarshall<uint32>((t_begin_of_data + 8), flags_, t_byteorder);
	
	// Parse "rest_words"
	int t_rest_words__arraylength = word_count() * 2 - 11;
	int t_rest_words__size = 1 * t_rest_words__arraylength;
	// Checking out-of-bound for "SMB_nt_create_andx:rest_words"
	if ( (t_begin_of_data + 12) + (t_rest_words__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_nt_create_andx:rest_words",
			(12) + (t_rest_words__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(rest_words_, t_rest_words__arraylength);
	const uint8* t_rest_words__elem__data = (t_begin_of_data + 12);
	for ( int t_rest_words__elem__it = 0; 
		t_rest_words__elem__it < t_rest_words__arraylength; 
		++t_rest_words__elem__it )
		{
		uint8 t_rest_words__elem;
		t_rest_words__elem = *((uint8 *) (t_rest_words__elem__data));
		rest_words_.v[t_rest_words__elem__it] = t_rest_words__elem;
		t_rest_words__elem__data += 1;
		}
	
	const uint8* const t_dataptr_after_rest_words = (t_begin_of_data + 12) + (t_rest_words__size);
	// Checking out-of-bound for "SMB_nt_create_andx:byte_count"
	if ( t_dataptr_after_rest_words + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_nt_create_andx:byte_count",
			((t_dataptr_after_rest_words - t_begin_of_data)) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte_count"
	byte_count_ = UnMarshall<uint16>(t_dataptr_after_rest_words, byte_count_, t_byteorder);
	
	// Parse "name"
	name_ = new SMB_string(unicode(), ((t_dataptr_after_rest_words + 2) - t_begin_of_data));
	int t_name__size = 
		name_->parse((t_dataptr_after_rest_words + 2), t_end_of_data, t_byteorder);
	
	const uint8* const t_dataptr_after_name = (t_dataptr_after_rest_words + 2) + (t_name__size);
	int t_val__size = t_dataptr_after_name - t_begin_of_data;
	return t_val__size;
	}

SMB_read_andx::SMB_read_andx()
	{
	word_count_ = 0;
	andx_ = 0;
	fid_ = 0;
	offset_ = 0;
	max_count_ = 0;
	min_count_ = 0;
	max_count_high_ = 0;
	remaining_ = 0;
	offset_high_ = 0;
	byte_count_ = 0;
	}

SMB_read_andx::~SMB_read_andx()
	{
	delete andx_;
	}

int SMB_read_andx::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_read_andx:val"
	if ( t_begin_of_data + (25) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_read_andx:val",
			(0) + (25), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "andx"
	andx_ = new SMB_andx();
	andx_->parse((t_begin_of_data + 1), t_end_of_data, t_byteorder);
	
	// Parse "fid"
	fid_ = UnMarshall<uint16>((t_begin_of_data + 5), fid_, t_byteorder);
	
	// Parse "offset"
	offset_ = UnMarshall<uint32>((t_begin_of_data + 7), offset_, t_byteorder);
	
	// Parse "max_count"
	max_count_ = UnMarshall<uint16>((t_begin_of_data + 11), max_count_, t_byteorder);
	
	// Parse "min_count"
	min_count_ = UnMarshall<uint16>((t_begin_of_data + 13), min_count_, t_byteorder);
	
	// Parse "max_count_high"
	max_count_high_ = UnMarshall<uint16>((t_begin_of_data + 15), max_count_high_, t_byteorder);
	
	// Parse "remaining"
	remaining_ = UnMarshall<uint16>((t_begin_of_data + 17), remaining_, t_byteorder);
	
	// Parse "offset_high"
	offset_high_ = UnMarshall<uint32>((t_begin_of_data + 19), offset_high_, t_byteorder);
	
	// Parse "byte_count"
	byte_count_ = UnMarshall<uint16>((t_begin_of_data + 23), byte_count_, t_byteorder);
	
	return 25;
	}

SMB_read_andx_response::SMB_read_andx_response()
	{
	word_count_ = 0;
	andx_ = 0;
	remaining_ = 0;
	data_compact_ = 0;
	reserved_ = 0;
	data_len_ = 0;
	data_offset_ = 0;
	data_len_high_ = 0;
	make_array(reserved2_, 0);
	byte_count_ = 0;
	data_length_ = 0;
	make_array(data_, 0);
	}

SMB_read_andx_response::~SMB_read_andx_response()
	{
	delete andx_;
	delete_array(reserved2_);
	delete_array(data_);
	}

int SMB_read_andx_response::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_read_andx_response:byte_count"
	if ( (t_begin_of_data + 25) + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_read_andx_response:byte_count",
			(25) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "andx"
	andx_ = new SMB_andx();
	andx_->parse((t_begin_of_data + 1), t_end_of_data, t_byteorder);
	
	// Parse "remaining"
	remaining_ = UnMarshall<uint16>((t_begin_of_data + 5), remaining_, t_byteorder);
	
	// Parse "data_compact"
	data_compact_ = UnMarshall<uint16>((t_begin_of_data + 7), data_compact_, t_byteorder);
	
	// Parse "reserved"
	reserved_ = UnMarshall<uint16>((t_begin_of_data + 9), reserved_, t_byteorder);
	
	// Parse "data_len"
	data_len_ = UnMarshall<uint16>((t_begin_of_data + 11), data_len_, t_byteorder);
	
	// Parse "data_offset"
	data_offset_ = UnMarshall<uint16>((t_begin_of_data + 13), data_offset_, t_byteorder);
	
	// Parse "data_len_high"
	data_len_high_ = UnMarshall<uint16>((t_begin_of_data + 15), data_len_high_, t_byteorder);
	
	// Parse "reserved2"
	int t_reserved2__arraylength = 4;
	make_array<uint16>(reserved2_, t_reserved2__arraylength);
	const uint8* t_reserved2__elem__data = (t_begin_of_data + 17);
	for ( int t_reserved2__elem__it = 0; 
		t_reserved2__elem__it < t_reserved2__arraylength; 
		++t_reserved2__elem__it )
		{
		uint16 t_reserved2__elem;
		t_reserved2__elem = UnMarshall<uint16>(t_reserved2__elem__data, t_reserved2__elem, t_byteorder);
		reserved2_.v[t_reserved2__elem__it] = t_reserved2__elem;
		t_reserved2__elem__data += 2;
		}
	
	// Parse "byte_count"
	byte_count_ = UnMarshall<uint16>((t_begin_of_data + 25), byte_count_, t_byteorder);
	
	
	data_length_ = data_len_high() * 0x10000 + data_len();
	
	const uint8* t_dataptr_after_pad = t_begin_of_data + (data_offset() - smb_header_length);
	if ( t_dataptr_after_pad < (t_begin_of_data + 27) )
		{
		// throw ExceptionInvalidOffset("./smb.pac:121:pad", (t_begin_of_data + 27) - t_begin_of_data, data_offset() - smb_header_length);
		t_dataptr_after_pad = (t_begin_of_data + 27);
		}
	// Parse "data"
	int t_data__arraylength = data_length();
	int t_data__size = 1 * t_data__arraylength;
	// Checking out-of-bound for "SMB_read_andx_response:data"
	if ( t_dataptr_after_pad + (t_data__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_read_andx_response:data",
			((t_dataptr_after_pad - t_begin_of_data)) + (t_data__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(data_, t_data__arraylength);
	const uint8* t_data__elem__data = t_dataptr_after_pad;
	for ( int t_data__elem__it = 0; 
		t_data__elem__it < t_data__arraylength; 
		++t_data__elem__it )
		{
		uint8 t_data__elem;
		t_data__elem = *((uint8 *) (t_data__elem__data));
		data_.v[t_data__elem__it] = t_data__elem;
		t_data__elem__data += 1;
		}
	
	const uint8* const t_dataptr_after_data = t_dataptr_after_pad + (t_data__size);
	int t_val__size = t_dataptr_after_data - t_begin_of_data;
	return t_val__size;
	}

SMB_write_andx::SMB_write_andx()
	{
	word_count_ = 0;
	andx_ = 0;
	fid_ = 0;
	offset_ = 0;
	reserved_ = 0;
	write_mode_ = 0;
	remaining_ = 0;
	data_len_high_ = 0;
	data_len_ = 0;
	data_offset_ = 0;
	make_array(rest_words_, 0);
	byte_count_ = 0;
	data_length_ = 0;
	make_array(data_, 0);
	}

SMB_write_andx::~SMB_write_andx()
	{
	delete andx_;
	delete_array(rest_words_);
	delete_array(data_);
	}

int SMB_write_andx::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_write_andx:data_offset"
	if ( (t_begin_of_data + 23) + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_write_andx:data_offset",
			(23) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "andx"
	andx_ = new SMB_andx();
	andx_->parse((t_begin_of_data + 1), t_end_of_data, t_byteorder);
	
	// Parse "fid"
	fid_ = UnMarshall<uint16>((t_begin_of_data + 5), fid_, t_byteorder);
	
	// Parse "offset"
	offset_ = UnMarshall<uint32>((t_begin_of_data + 7), offset_, t_byteorder);
	
	// Parse "reserved"
	reserved_ = UnMarshall<uint32>((t_begin_of_data + 11), reserved_, t_byteorder);
	
	// Parse "write_mode"
	write_mode_ = UnMarshall<uint16>((t_begin_of_data + 15), write_mode_, t_byteorder);
	
	// Parse "remaining"
	remaining_ = UnMarshall<uint16>((t_begin_of_data + 17), remaining_, t_byteorder);
	
	// Parse "data_len_high"
	data_len_high_ = UnMarshall<uint16>((t_begin_of_data + 19), data_len_high_, t_byteorder);
	
	// Parse "data_len"
	data_len_ = UnMarshall<uint16>((t_begin_of_data + 21), data_len_, t_byteorder);
	
	// Parse "data_offset"
	data_offset_ = UnMarshall<uint16>((t_begin_of_data + 23), data_offset_, t_byteorder);
	
	// Parse "rest_words"
	int t_rest_words__arraylength = word_count() * 2 - 25 + 1;
	int t_rest_words__size = 1 * t_rest_words__arraylength;
	// Checking out-of-bound for "SMB_write_andx:rest_words"
	if ( (t_begin_of_data + 25) + (t_rest_words__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_write_andx:rest_words",
			(25) + (t_rest_words__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(rest_words_, t_rest_words__arraylength);
	const uint8* t_rest_words__elem__data = (t_begin_of_data + 25);
	for ( int t_rest_words__elem__it = 0; 
		t_rest_words__elem__it < t_rest_words__arraylength; 
		++t_rest_words__elem__it )
		{
		uint8 t_rest_words__elem;
		t_rest_words__elem = *((uint8 *) (t_rest_words__elem__data));
		rest_words_.v[t_rest_words__elem__it] = t_rest_words__elem;
		t_rest_words__elem__data += 1;
		}
	
	const uint8* const t_dataptr_after_rest_words = (t_begin_of_data + 25) + (t_rest_words__size);
	// Checking out-of-bound for "SMB_write_andx:byte_count"
	if ( t_dataptr_after_rest_words + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_write_andx:byte_count",
			((t_dataptr_after_rest_words - t_begin_of_data)) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte_count"
	byte_count_ = UnMarshall<uint16>(t_dataptr_after_rest_words, byte_count_, t_byteorder);
	
	
	data_length_ = data_len_high() * 0x10000 + data_len();
	
	const uint8* t_dataptr_after_pad = t_begin_of_data + (data_offset() - smb_header_length);
	if ( t_dataptr_after_pad < (t_dataptr_after_rest_words + 2) )
		{
		// throw ExceptionInvalidOffset("./smb.pac:139:pad", (t_dataptr_after_rest_words + 2) - t_begin_of_data, data_offset() - smb_header_length);
		t_dataptr_after_pad = (t_dataptr_after_rest_words + 2);
		}
	// Parse "data"
	int t_data__arraylength = data_length();
	int t_data__size = 1 * t_data__arraylength;
	// Checking out-of-bound for "SMB_write_andx:data"
	if ( t_dataptr_after_pad + (t_data__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_write_andx:data",
			((t_dataptr_after_pad - t_begin_of_data)) + (t_data__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(data_, t_data__arraylength);
	const uint8* t_data__elem__data = t_dataptr_after_pad;
	for ( int t_data__elem__it = 0; 
		t_data__elem__it < t_data__arraylength; 
		++t_data__elem__it )
		{
		uint8 t_data__elem;
		t_data__elem = *((uint8 *) (t_data__elem__data));
		data_.v[t_data__elem__it] = t_data__elem;
		t_data__elem__data += 1;
		}
	
	const uint8* const t_dataptr_after_data = t_dataptr_after_pad + (t_data__size);
	int t_val__size = t_dataptr_after_data - t_begin_of_data;
	return t_val__size;
	}

SMB_write_andx_response::SMB_write_andx_response()
	{
	word_count_ = 0;
	andx_ = 0;
	count_ = 0;
	remaining_ = 0;
	reserved_ = 0;
	byte_count_ = 0;
	}

SMB_write_andx_response::~SMB_write_andx_response()
	{
	delete andx_;
	}

int SMB_write_andx_response::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_write_andx_response:val"
	if ( t_begin_of_data + (15) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_write_andx_response:val",
			(0) + (15), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "andx"
	andx_ = new SMB_andx();
	andx_->parse((t_begin_of_data + 1), t_end_of_data, t_byteorder);
	
	// Parse "count"
	count_ = UnMarshall<uint16>((t_begin_of_data + 5), count_, t_byteorder);
	
	// Parse "remaining"
	remaining_ = UnMarshall<uint16>((t_begin_of_data + 7), remaining_, t_byteorder);
	
	// Parse "reserved"
	reserved_ = UnMarshall<uint32>((t_begin_of_data + 9), reserved_, t_byteorder);
	
	// Parse "byte_count"
	byte_count_ = UnMarshall<uint16>((t_begin_of_data + 13), byte_count_, t_byteorder);
	
	return 15;
	}

SMB_transaction::SMB_transaction(int arg_trans_type, int arg_unicode)
	{
	trans_type_ = arg_trans_type;
	unicode_ = arg_unicode;
	word_count_ = 0;
	total_param_count_ = 0;
	total_data_count_ = 0;
	max_param_count_ = 0;
	max_data_count_ = 0;
	max_setup_count_ = 0;
	reserved_ = 0;
	flags_ = 0;
	timeout_ = 0;
	reserved2_ = 0;
	param_count_ = 0;
	param_offset_ = 0;
	data_count_ = 0;
	data_offset_ = 0;
	setup_count_ = 0;
	reserved3_ = 0;
	make_array(setup_, 0);
	byte_count_ = 0;
	name_u_case_index_ = -1;
	make_array(parameters_, 0);
	make_array(data_, 0);
	}

SMB_transaction::~SMB_transaction()
	{
	delete_array(setup_);
	switch ( name_u_case_index() )
		{
		case 1:
			// Clean up "name"
			{
			delete name_u_.name_;
			}
			break;
		case 2:
			// Clean up "null"
			{
			}
			break;
		}
	delete_array(parameters_);
	delete_array(data_);
	}

int SMB_transaction::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_transaction:reserved3"
	if ( (t_begin_of_data + 28) + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction:reserved3",
			(28) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "total_param_count"
	total_param_count_ = UnMarshall<uint16>((t_begin_of_data + 1), total_param_count_, t_byteorder);
	
	// Parse "total_data_count"
	total_data_count_ = UnMarshall<uint16>((t_begin_of_data + 3), total_data_count_, t_byteorder);
	
	// Parse "max_param_count"
	max_param_count_ = UnMarshall<uint16>((t_begin_of_data + 5), max_param_count_, t_byteorder);
	
	// Parse "max_data_count"
	max_data_count_ = UnMarshall<uint16>((t_begin_of_data + 7), max_data_count_, t_byteorder);
	
	// Parse "max_setup_count"
	max_setup_count_ = *((uint8 *) ((t_begin_of_data + 9)));
	
	// Parse "reserved"
	reserved_ = *((uint8 *) ((t_begin_of_data + 10)));
	
	// Parse "flags"
	flags_ = UnMarshall<uint16>((t_begin_of_data + 11), flags_, t_byteorder);
	
	// Parse "timeout"
	timeout_ = UnMarshall<uint32>((t_begin_of_data + 13), timeout_, t_byteorder);
	
	// Parse "reserved2"
	reserved2_ = UnMarshall<uint16>((t_begin_of_data + 17), reserved2_, t_byteorder);
	
	// Parse "param_count"
	param_count_ = UnMarshall<uint16>((t_begin_of_data + 19), param_count_, t_byteorder);
	
	// Parse "param_offset"
	param_offset_ = UnMarshall<uint16>((t_begin_of_data + 21), param_offset_, t_byteorder);
	
	// Parse "data_count"
	data_count_ = UnMarshall<uint16>((t_begin_of_data + 23), data_count_, t_byteorder);
	
	// Parse "data_offset"
	data_offset_ = UnMarshall<uint16>((t_begin_of_data + 25), data_offset_, t_byteorder);
	
	// Parse "setup_count"
	setup_count_ = *((uint8 *) ((t_begin_of_data + 27)));
	
	// Parse "reserved3"
	reserved3_ = *((uint8 *) ((t_begin_of_data + 28)));
	
	// Parse "setup"
	int t_setup__arraylength = setup_count();
	int t_setup__size = 2 * t_setup__arraylength;
	// Checking out-of-bound for "SMB_transaction:setup"
	if ( (t_begin_of_data + 29) + (t_setup__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction:setup",
			(29) + (t_setup__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint16>(setup_, t_setup__arraylength);
	const uint8* t_setup__elem__data = (t_begin_of_data + 29);
	for ( int t_setup__elem__it = 0; 
		t_setup__elem__it < t_setup__arraylength; 
		++t_setup__elem__it )
		{
		uint16 t_setup__elem;
		t_setup__elem = UnMarshall<uint16>(t_setup__elem__data, t_setup__elem, t_byteorder);
		setup_.v[t_setup__elem__it] = t_setup__elem;
		t_setup__elem__data += 2;
		}
	
	const uint8* const t_dataptr_after_setup = (t_begin_of_data + 29) + (t_setup__size);
	// Checking out-of-bound for "SMB_transaction:byte_count"
	if ( t_dataptr_after_setup + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction:byte_count",
			((t_dataptr_after_setup - t_begin_of_data)) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte_count"
	byte_count_ = UnMarshall<uint16>(t_dataptr_after_setup, byte_count_, t_byteorder);
	
	// Parse "name_u"
	int t_name_u__size;
	name_u_case_index_ = trans_type();
	switch ( name_u_case_index() )
		{
		case 1:
			// Parse "name"
			{
			name_u_.name_ = new SMB_string(unicode(), ((t_dataptr_after_setup + 2) - t_begin_of_data));
			int t_name__size = 
				name_u_.name_->parse((t_dataptr_after_setup + 2), t_end_of_data, t_byteorder);
			t_name_u__size = t_name__size;
			}
			break;
		case 2:
			// Parse "null"
			{
			// Checking out-of-bound for "SMB_transaction:null"
			if ( (t_dataptr_after_setup + 2) + (0) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("SMB_transaction:null",
					(((t_dataptr_after_setup + 2) - t_begin_of_data)) + (0), 
					(t_end_of_data) - (t_begin_of_data));
				}
			t_name_u__size = 0;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("SMB_transaction", name_u_case_index());
			break;
		}
	
	
	const uint8* const t_dataptr_after_name_u = (t_dataptr_after_setup + 2) + (t_name_u__size);
	const uint8* t_dataptr_after_pad0 = t_begin_of_data + (param_offset() - smb_header_length);
	if ( t_dataptr_after_pad0 < t_dataptr_after_name_u )
		{
		// throw ExceptionInvalidOffset("./smb.pac:176:pad0", t_dataptr_after_name_u - t_begin_of_data, param_offset() - smb_header_length);
		t_dataptr_after_pad0 = t_dataptr_after_name_u;
		}
	// Parse "parameters"
	int t_parameters__arraylength = param_count();
	int t_parameters__size = 1 * t_parameters__arraylength;
	// Checking out-of-bound for "SMB_transaction:parameters"
	if ( t_dataptr_after_pad0 + (t_parameters__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction:parameters",
			((t_dataptr_after_pad0 - t_begin_of_data)) + (t_parameters__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(parameters_, t_parameters__arraylength);
	const uint8* t_parameters__elem__data = t_dataptr_after_pad0;
	for ( int t_parameters__elem__it = 0; 
		t_parameters__elem__it < t_parameters__arraylength; 
		++t_parameters__elem__it )
		{
		uint8 t_parameters__elem;
		t_parameters__elem = *((uint8 *) (t_parameters__elem__data));
		parameters_.v[t_parameters__elem__it] = t_parameters__elem;
		t_parameters__elem__data += 1;
		}
	
	
	const uint8* const t_dataptr_after_parameters = t_dataptr_after_pad0 + (t_parameters__size);
	const uint8* t_dataptr_after_pad1 = t_begin_of_data + (data_offset() - smb_header_length);
	if ( t_dataptr_after_pad1 < t_dataptr_after_parameters )
		{
		// throw ExceptionInvalidOffset("./smb.pac:178:pad1", t_dataptr_after_parameters - t_begin_of_data, data_offset() - smb_header_length);
		t_dataptr_after_pad1 = t_dataptr_after_parameters;
		}
	// Parse "data"
	int t_data__arraylength = data_count();
	int t_data__size = 1 * t_data__arraylength;
	// Checking out-of-bound for "SMB_transaction:data"
	if ( t_dataptr_after_pad1 + (t_data__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction:data",
			((t_dataptr_after_pad1 - t_begin_of_data)) + (t_data__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(data_, t_data__arraylength);
	const uint8* t_data__elem__data = t_dataptr_after_pad1;
	for ( int t_data__elem__it = 0; 
		t_data__elem__it < t_data__arraylength; 
		++t_data__elem__it )
		{
		uint8 t_data__elem;
		t_data__elem = *((uint8 *) (t_data__elem__data));
		data_.v[t_data__elem__it] = t_data__elem;
		t_data__elem__data += 1;
		}
	
	const uint8* const t_dataptr_after_data = t_dataptr_after_pad1 + (t_data__size);
	int t_val__size = t_dataptr_after_data - t_begin_of_data;
	return t_val__size;
	}

SMB_transaction_secondary::SMB_transaction_secondary(int arg_unicode)
	{
	unicode_ = arg_unicode;
	smb_header_length_ = 32;
	word_count_ = 0;
	total_param_count_ = 0;
	total_data_count_ = 0;
	param_count_ = 0;
	param_offset_ = 0;
	param_displacement_ = 0;
	data_count_ = 0;
	data_offset_ = 0;
	data_displacement_ = 0;
	fid_ = 0;
	byte_count_ = 0;
	make_array(parameters_, 0);
	make_array(data_, 0);
	}

SMB_transaction_secondary::~SMB_transaction_secondary()
	{
	delete_array(parameters_);
	delete_array(data_);
	}

int SMB_transaction_secondary::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	
	// Checking out-of-bound for "SMB_transaction_secondary:byte_count"
	if ( (t_begin_of_data + 19) + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_secondary:byte_count",
			(19) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "total_param_count"
	total_param_count_ = UnMarshall<uint16>((t_begin_of_data + 1), total_param_count_, t_byteorder);
	
	// Parse "total_data_count"
	total_data_count_ = UnMarshall<uint16>((t_begin_of_data + 3), total_data_count_, t_byteorder);
	
	// Parse "param_count"
	param_count_ = UnMarshall<uint16>((t_begin_of_data + 5), param_count_, t_byteorder);
	
	// Parse "param_offset"
	param_offset_ = UnMarshall<uint16>((t_begin_of_data + 7), param_offset_, t_byteorder);
	
	// Parse "param_displacement"
	param_displacement_ = UnMarshall<uint16>((t_begin_of_data + 9), param_displacement_, t_byteorder);
	
	// Parse "data_count"
	data_count_ = UnMarshall<uint16>((t_begin_of_data + 11), data_count_, t_byteorder);
	
	// Parse "data_offset"
	data_offset_ = UnMarshall<uint16>((t_begin_of_data + 13), data_offset_, t_byteorder);
	
	// Parse "data_displacement"
	data_displacement_ = UnMarshall<uint16>((t_begin_of_data + 15), data_displacement_, t_byteorder);
	
	// Parse "fid"
	fid_ = UnMarshall<uint16>((t_begin_of_data + 17), fid_, t_byteorder);
	
	// Parse "byte_count"
	byte_count_ = UnMarshall<uint16>((t_begin_of_data + 19), byte_count_, t_byteorder);
	
	
	const uint8* t_dataptr_after_pad0 = t_begin_of_data + (param_offset() - smb_header_length());
	if ( t_dataptr_after_pad0 < (t_begin_of_data + 21) )
		{
		// throw ExceptionInvalidOffset("./smb.pac:196:pad0", (t_begin_of_data + 21) - t_begin_of_data, param_offset() - smb_header_length());
		t_dataptr_after_pad0 = (t_begin_of_data + 21);
		}
	// Parse "parameters"
	int t_parameters__arraylength = param_count();
	int t_parameters__size = 1 * t_parameters__arraylength;
	// Checking out-of-bound for "SMB_transaction_secondary:parameters"
	if ( t_dataptr_after_pad0 + (t_parameters__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_secondary:parameters",
			((t_dataptr_after_pad0 - t_begin_of_data)) + (t_parameters__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(parameters_, t_parameters__arraylength);
	const uint8* t_parameters__elem__data = t_dataptr_after_pad0;
	for ( int t_parameters__elem__it = 0; 
		t_parameters__elem__it < t_parameters__arraylength; 
		++t_parameters__elem__it )
		{
		uint8 t_parameters__elem;
		t_parameters__elem = *((uint8 *) (t_parameters__elem__data));
		parameters_.v[t_parameters__elem__it] = t_parameters__elem;
		t_parameters__elem__data += 1;
		}
	
	
	const uint8* const t_dataptr_after_parameters = t_dataptr_after_pad0 + (t_parameters__size);
	const uint8* t_dataptr_after_pad1 = t_begin_of_data + (data_offset() - smb_header_length());
	if ( t_dataptr_after_pad1 < t_dataptr_after_parameters )
		{
		// throw ExceptionInvalidOffset("./smb.pac:198:pad1", t_dataptr_after_parameters - t_begin_of_data, data_offset() - smb_header_length());
		t_dataptr_after_pad1 = t_dataptr_after_parameters;
		}
	// Parse "data"
	int t_data__arraylength = data_count();
	int t_data__size = 1 * t_data__arraylength;
	// Checking out-of-bound for "SMB_transaction_secondary:data"
	if ( t_dataptr_after_pad1 + (t_data__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_secondary:data",
			((t_dataptr_after_pad1 - t_begin_of_data)) + (t_data__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(data_, t_data__arraylength);
	const uint8* t_data__elem__data = t_dataptr_after_pad1;
	for ( int t_data__elem__it = 0; 
		t_data__elem__it < t_data__arraylength; 
		++t_data__elem__it )
		{
		uint8 t_data__elem;
		t_data__elem = *((uint8 *) (t_data__elem__data));
		data_.v[t_data__elem__it] = t_data__elem;
		t_data__elem__data += 1;
		}
	
	const uint8* const t_dataptr_after_data = t_dataptr_after_pad1 + (t_data__size);
	int t_val__size = t_dataptr_after_data - t_begin_of_data;
	return t_val__size;
	}

SMB_transaction_response::SMB_transaction_response(int arg_unicode)
	{
	unicode_ = arg_unicode;
	smb_header_length_ = 32;
	word_count_ = 0;
	total_param_count_ = 0;
	total_data_count_ = 0;
	reserved_ = 0;
	param_count_ = 0;
	param_offset_ = 0;
	param_displacement_ = 0;
	data_count_ = 0;
	data_offset_ = 0;
	data_displacement_ = 0;
	setup_count_ = 0;
	reserved2_ = 0;
	make_array(setup_, 0);
	byte_count_ = 0;
	make_array(parameters_, 0);
	make_array(data_, 0);
	}

SMB_transaction_response::~SMB_transaction_response()
	{
	delete_array(setup_);
	delete_array(parameters_);
	delete_array(data_);
	}

int SMB_transaction_response::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	
	// Checking out-of-bound for "SMB_transaction_response:reserved2"
	if ( (t_begin_of_data + 20) + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_response:reserved2",
			(20) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "total_param_count"
	total_param_count_ = UnMarshall<uint16>((t_begin_of_data + 1), total_param_count_, t_byteorder);
	
	// Parse "total_data_count"
	total_data_count_ = UnMarshall<uint16>((t_begin_of_data + 3), total_data_count_, t_byteorder);
	
	// Parse "reserved"
	reserved_ = UnMarshall<uint16>((t_begin_of_data + 5), reserved_, t_byteorder);
	
	// Parse "param_count"
	param_count_ = UnMarshall<uint16>((t_begin_of_data + 7), param_count_, t_byteorder);
	
	// Parse "param_offset"
	param_offset_ = UnMarshall<uint16>((t_begin_of_data + 9), param_offset_, t_byteorder);
	
	// Parse "param_displacement"
	param_displacement_ = UnMarshall<uint16>((t_begin_of_data + 11), param_displacement_, t_byteorder);
	
	// Parse "data_count"
	data_count_ = UnMarshall<uint16>((t_begin_of_data + 13), data_count_, t_byteorder);
	
	// Parse "data_offset"
	data_offset_ = UnMarshall<uint16>((t_begin_of_data + 15), data_offset_, t_byteorder);
	
	// Parse "data_displacement"
	data_displacement_ = UnMarshall<uint16>((t_begin_of_data + 17), data_displacement_, t_byteorder);
	
	// Parse "setup_count"
	setup_count_ = *((uint8 *) ((t_begin_of_data + 19)));
	
	// Parse "reserved2"
	reserved2_ = *((uint8 *) ((t_begin_of_data + 20)));
	
	// Parse "setup"
	int t_setup__arraylength = setup_count();
	int t_setup__size = 2 * t_setup__arraylength;
	// Checking out-of-bound for "SMB_transaction_response:setup"
	if ( (t_begin_of_data + 21) + (t_setup__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_response:setup",
			(21) + (t_setup__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint16>(setup_, t_setup__arraylength);
	const uint8* t_setup__elem__data = (t_begin_of_data + 21);
	for ( int t_setup__elem__it = 0; 
		t_setup__elem__it < t_setup__arraylength; 
		++t_setup__elem__it )
		{
		uint16 t_setup__elem;
		t_setup__elem = UnMarshall<uint16>(t_setup__elem__data, t_setup__elem, t_byteorder);
		setup_.v[t_setup__elem__it] = t_setup__elem;
		t_setup__elem__data += 2;
		}
	
	const uint8* const t_dataptr_after_setup = (t_begin_of_data + 21) + (t_setup__size);
	// Checking out-of-bound for "SMB_transaction_response:byte_count"
	if ( t_dataptr_after_setup + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_response:byte_count",
			((t_dataptr_after_setup - t_begin_of_data)) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte_count"
	byte_count_ = UnMarshall<uint16>(t_dataptr_after_setup, byte_count_, t_byteorder);
	
	
	const uint8* t_dataptr_after_pad0 = t_begin_of_data + (param_offset() - smb_header_length());
	if ( t_dataptr_after_pad0 < (t_dataptr_after_setup + 2) )
		{
		// throw ExceptionInvalidOffset("./smb.pac:219:pad0", (t_dataptr_after_setup + 2) - t_begin_of_data, param_offset() - smb_header_length());
		t_dataptr_after_pad0 = (t_dataptr_after_setup + 2);
		}
	// Parse "parameters"
	int t_parameters__arraylength = param_count();
	int t_parameters__size = 1 * t_parameters__arraylength;
	// Checking out-of-bound for "SMB_transaction_response:parameters"
	if ( t_dataptr_after_pad0 + (t_parameters__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_response:parameters",
			((t_dataptr_after_pad0 - t_begin_of_data)) + (t_parameters__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(parameters_, t_parameters__arraylength);
	const uint8* t_parameters__elem__data = t_dataptr_after_pad0;
	for ( int t_parameters__elem__it = 0; 
		t_parameters__elem__it < t_parameters__arraylength; 
		++t_parameters__elem__it )
		{
		uint8 t_parameters__elem;
		t_parameters__elem = *((uint8 *) (t_parameters__elem__data));
		parameters_.v[t_parameters__elem__it] = t_parameters__elem;
		t_parameters__elem__data += 1;
		}
	
	
	const uint8* const t_dataptr_after_parameters = t_dataptr_after_pad0 + (t_parameters__size);
	const uint8* t_dataptr_after_pad1 = t_begin_of_data + (data_offset() - smb_header_length());
	if ( t_dataptr_after_pad1 < t_dataptr_after_parameters )
		{
		// throw ExceptionInvalidOffset("./smb.pac:221:pad1", t_dataptr_after_parameters - t_begin_of_data, data_offset() - smb_header_length());
		t_dataptr_after_pad1 = t_dataptr_after_parameters;
		}
	// Parse "data"
	int t_data__arraylength = data_count();
	int t_data__size = 1 * t_data__arraylength;
	// Checking out-of-bound for "SMB_transaction_response:data"
	if ( t_dataptr_after_pad1 + (t_data__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_response:data",
			((t_dataptr_after_pad1 - t_begin_of_data)) + (t_data__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(data_, t_data__arraylength);
	const uint8* t_data__elem__data = t_dataptr_after_pad1;
	for ( int t_data__elem__it = 0; 
		t_data__elem__it < t_data__arraylength; 
		++t_data__elem__it )
		{
		uint8 t_data__elem;
		t_data__elem = *((uint8 *) (t_data__elem__data));
		data_.v[t_data__elem__it] = t_data__elem;
		t_data__elem__data += 1;
		}
	
	const uint8* const t_dataptr_after_data = t_dataptr_after_pad1 + (t_data__size);
	int t_val__size = t_dataptr_after_data - t_begin_of_data;
	return t_val__size;
	}

SMB_get_dfs_referral::SMB_get_dfs_referral(int arg_unicode)
	{
	unicode_ = arg_unicode;
	max_referral_level_ = 0;
	file_name_ = 0;
	}

SMB_get_dfs_referral::~SMB_get_dfs_referral()
	{
	delete file_name_;
	}

int SMB_get_dfs_referral::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_get_dfs_referral:max_referral_level"
	if ( t_begin_of_data + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_get_dfs_referral:max_referral_level",
			(0) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "max_referral_level"
	max_referral_level_ = UnMarshall<uint16>(t_begin_of_data, max_referral_level_, t_byteorder);
	
	// Parse "file_name"
	file_name_ = new SMB_string(unicode(), 2);
	int t_file_name__size = 
		file_name_->parse((t_begin_of_data + 2), t_end_of_data, t_byteorder);
	
	const uint8* const t_dataptr_after_file_name = (t_begin_of_data + 2) + (t_file_name__size);
	int t_val__size = t_dataptr_after_file_name - t_begin_of_data;
	return t_val__size;
	}

} /* namespace BinPAC */
